'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 19 August 2002 at 5:11:45 pm'!
"Change Set:		MorphTest
Date:			19 August 2002
Author:			NISHIHARA Satoshi

TestCases for TransfoimingAMorphFix."!

TestCase subclass: #MorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Kernel'!

!MorphTest methodsFor: 'Testing' stamp: 'ns 8/19/2002 15:14'!
testDismissMorph
	| rectangle rectangleId ellipse ellipseId ellipseExist rectangleExist |
	rectangle _ RectangleMorph new.
	rectangleId _ rectangle identityHash.
	ellipse _ EllipseMorph new.
	ellipseId _ ellipse identityHash.
	rectangle addMorph: ellipse.
	rectangle openInWorld.
	rectangle topRendererOrSelf dismissMorph: nil.
	rectangle _ ellipse _ nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	ellipseExist _ EllipseMorph allInstances
				detect: [:each | each identityHash == ellipseId]
				ifNone: [].
	rectangleExist _ RectangleMorph allInstances
				detect: [:each | each identityHash == rectangleId]
				ifNone: [].
	self
		should: [ellipseExist isNil].
	self
		should: [rectangleExist isNil]! !

!MorphTest methodsFor: 'Testing' stamp: 'ns 8/19/2002 15:14'!
testDismissMorphForTransformation
	| rectangle rectangleId ellipse ellipseId ellipseExist rectangleExist |
	rectangle _ RectangleMorph new.
	rectangleId _ rectangle identityHash.
	rectangle openInWorld.
	rectangle heading: 100.
	ellipse _ EllipseMorph new.
	ellipseId _ ellipse identityHash.
	rectangle addMorph: ellipse.
	rectangle topRendererOrSelf dismissMorph: nil.
	rectangle _ ellipse _ nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	ellipseExist _ EllipseMorph allInstances
				detect: [:each | each identityHash == ellipseId]
				ifNone: [].
	rectangleExist _ RectangleMorph allInstances
				detect: [:each | each identityHash == rectangleId]
				ifNone: [].
	self
		should: [ellipseExist isNil].
	self
		should: [rectangleExist isNil]! !

!MorphTest methodsFor: 'Testing' stamp: 'ns 8/19/2002 15:13'!
testLocalHaloBoundsFor
	| rectangleMorph halo befor after |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.

	halo _ HaloMorph new setTarget: rectangleMorph.
	befor _	 halo localHaloBoundsFor: rectangleMorph.

	rectangleMorph heading: 90.

	halo _ HaloMorph new setTarget: rectangleMorph.
	after _	 halo localHaloBoundsFor: rectangleMorph topRendererOrSelf.
	self should: [befor width == (after height - 2)].
	self should: [befor height == (after width - 2)].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: 'Testing' stamp: 'ns 8/19/2002 15:13'!
testPrivateAddMorphAtIndex
	| rectangleMorph ellipseMorph event |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 50 @ 100.
	ellipseMorph openInWorld.
	ellipseMorph position: 100 @ 130.
	ellipseMorph heading: 90.
	event _ DropEvent new.
	"event type: #dropEvent."
	event
		setPosition: -100.0 @ 24.0
		contents: ellipseMorph topRendererOrSelf
		hand: HandMorph new.
	rectangleMorph acceptDroppingMorph: ellipseMorph topRendererOrSelf event: event.
	ellipseMorph topRendererOrSelf position: -45 @ -40.
	self
		should: [rectangleMorph submorphs includes: ellipseMorph topRendererOrSelf].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: 'Testing' stamp: 'ns 8/19/2002 15:12'!
testSaveOnFile
	| rectangleMorph ellipseMorph event aStream theMorph submorph savingBlock aFileName |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 50 @ 100.
	ellipseMorph openInWorld.
	ellipseMorph position: 100 @ 130.
	ellipseMorph heading: 90.
	event _ DropEvent new.
	event
		setPosition: -100.0 @ 24.0
		contents: ellipseMorph topRendererOrSelf
		hand: HandMorph new.
	rectangleMorph acceptDroppingMorph: ellipseMorph topRendererOrSelf event: event.
	ellipseMorph topRendererOrSelf position: -45 @ -40.
	"rectangleMorph saveOnFile."
	aFileName _ '__Test.morph'.
	FileDirectory default deleteFileNamed: aFileName.
	savingBlock _ [:morph | 
			| fileStream topRendererOrSelf | 
			topRendererOrSelf _ morph topRendererOrSelf.
			topRendererOrSelf
				allMorphsDo: [:m | m prepareToBeSaved].
			fileStream _ FileStream newFileNamed: aFileName.
			fileStream fileOutClass: nil andObject: topRendererOrSelf].
	savingBlock value: rectangleMorph.
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	aStream _ FileStream oldFileNamed: '__Test.morph'.
	theMorph _ Morph readFrom: aStream.
	theMorph openInWorld.
	submorph _ theMorph renderedMorph submorphs
				detect: [:each | each isKindOf: TransformationMorph]
				ifNone: [].
	self
		should: [submorph notNil].
	self
		should: [submorph renderedMorph isKindOf: EllipseMorph].
	theMorph topRendererOrSelf dismissMorph: nil.
	FileDirectory default deleteFileNamed: aFileName.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: 'Testing' stamp: 'ns 8/19/2002 15:12'!
testScaleToMatch
	| rectangleMorph ellipseMorph event before after |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 50 @ 100.
	ellipseMorph openInWorld.
	ellipseMorph position: 100 @ 130.
	ellipseMorph heading: 90.
	event _ DropEvent new.
	"event type: #dropEvent."
	event
		setPosition: -100.0 @ 24.0
		contents: ellipseMorph topRendererOrSelf
		hand: HandMorph new.
	rectangleMorph acceptDroppingMorph: ellipseMorph topRendererOrSelf event: event.
	ellipseMorph topRendererOrSelf position: -45 @ -40.
	before _ ellipseMorph topRendererOrSelf bounds area.
	ellipseMorph topRendererOrSelf scaleToMatch: 246 @ 310.
	after _ ellipseMorph topRendererOrSelf bounds area.
	self
		should: [before == 5304].
	self
		should: [after == 6160].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: 'Testing' stamp: 'ns 8/19/2002 15:13'!
testWithOffsetOfCompositeTransform
	| compositeTransform rectangleMorph |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	compositeTransform _ rectangleMorph topRendererOrSelf transform composedWith: rectangleMorph topRendererOrSelf transform.
	self
		should: [compositeTransform respondsTo: #withOffset:].
	self
		should: [compositeTransform offset = (50.0 @ -450.0)].
	self
		should: [compositeTransform scale = 1.0].
	self
		should: [compositeTransform angle = -3.141592653589793].
	compositeTransform withOffset: 1 @ 1.
	self
		should: [compositeTransform offset = (-201.0 @ -249.0)].
	self
		should: [compositeTransform scale = 1.0].
	self
		should: [compositeTransform angle = -3.141592653589793].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: 'Testing' stamp: 'ns 8/19/2002 15:13'!
testWithOffsetOfDisplayTransform
	| displayTransform |
	displayTransform _ DisplayTransform new.
	self
		should: [displayTransform respondsTo: #withOffset:].
	self
		should: [[displayTransform withOffset: 2 @ 2.
			false]
				on: Error
				do: [:ex | true]]! !

