'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 19 August 2002 at 8:02:29 pm'!
"Change Set:		TransfoimingAMorphFix
Date:			19 August 2002
Author:			KURIHARA Tetsuya
				ABE Kazuhiro
				NISHIHARA Satoshi

Some kind of strange behaviors appears when aTransformationMorph (of EllipseMorph) is dropped in aMorph or aTransformationMorph (of RectangleMorph).

1. create aMorph from flaptabs.
2. scale and rotate it.
3. set 'accept drops' to on.
4. create another morph.
5. scale and rotate it, if necessary.
6. drop morph: 4 to morph: 1.
and scaling/pick up and moving/rotating will cause errors or warnings.

This change set will fix below...

1. adding aMorph or aTransformationMorph to aMorph or aTransformationMorph.
2. scaling aTransformationMorph within aMorph or aTransformationMorph of dropping accepted.
3. rotating aTransformationMorph within aMorph or aTransformationMorph of dropping accepted.
4. positioning a halo of aTransformationMorph within aMorph or aTransformationMorph of dropping accepted.
and
5. save and load aMorph dropping accepted.
6. dismiss aMorph with its submorphs.

#### caution: this change set will adapt the aTransformationMorph to PolygonMorphs. ####

Enjoy playing with Morphs!!
"!


!DisplayTransform methodsFor: 'accessing' stamp: 'ns 8/16/2002 17:30'!
withOffset: aPoint
	^ self subclassResponsibility! !


!CompositeTransform methodsFor: 'accessing' stamp: 'ns 8/16/2002 15:06'!
withOffset: aPoint 
	^ localTransform _ localTransform withOffset: aPoint! !


!Morph methodsFor: 'private' stamp: 'ns 8/16/2002 15:47'!
privateAddMorph: aMorph atIndex: index

	| oldIndex myWorld itsWorld |
	((index >= 1) and: [index <= (submorphs size + 1)])
		ifFalse: [^ self error: 'index out of range'].
	myWorld _ self world.
	(aMorph owner == self and: [(oldIndex _ submorphs indexOf: aMorph) > 0])
		ifTrue:
		["aMorph's position changes within in the submorph chain"
		oldIndex < index
			ifTrue:
			["moving aMorph to back"
			submorphs replaceFrom: oldIndex to: index-2 with: submorphs startingAt: oldIndex+1.
			submorphs at: index-1 put: aMorph]
			ifFalse:
			["moving aMorph to front"
			oldIndex-1 to: index by: -1 do:[:i|
				submorphs at: i+1 put: (submorphs at: i)].
			submorphs at: index put: aMorph]]
		ifFalse:
		["adding a new morph"
		aMorph owner ifNotNil:
			[itsWorld _ aMorph world.
			itsWorld == myWorld ifFalse: [aMorph outOfWorld: itsWorld].
			aMorph owner privateRemoveMorph: aMorph].
		aMorph privateOwner: self.
		submorphs _ submorphs copyReplaceFrom: index to: index-1 with: (Array with: aMorph).
		itsWorld == myWorld ifFalse:[aMorph intoWorld: myWorld]].
	aMorph layoutChanged.
	self layoutChanged.
	myWorld ifNotNil: [self addedOrRemovedSubmorph: aMorph].! !

!Morph methodsFor: 'fileIn/out' stamp: 'ka 7/26/2002 17:02'!
saveOnFile
	"Ask the user for a filename and save myself on a SmartReferenceStream file.  Writes out the version and class structure.  The file is fileIn-able.  UniClasses will be filed out."

	| aFileName fileStream ok topRendererOrSelf |
	aFileName _ ('my ', self class name) asFileName.	"do better?"
	aFileName _ FillInTheBlank request: 'File name? (".morph" will be added to end)' 
			initialAnswer: aFileName.
	aFileName size == 0 ifTrue: [^ self beep].
	topRendererOrSelf _ self topRendererOrSelf.
	topRendererOrSelf
		allMorphsDo: [:m | m prepareToBeSaved].

	ok _ aFileName endsWith: '.morph'.	"don't double them"
	ok _ ok | (aFileName endsWith: '.sp').
	ok ifFalse: [aFileName _ aFileName,'.morph'].
	fileStream _ FileStream newFileNamed: aFileName.
	fileStream fileOutClass: nil andObject: topRendererOrSelf.	"Puts UniClass definitions out anyway"! !

!Morph methodsFor: 'meta-actions' stamp: 'ns 8/19/2002 15:15'!
dismissMorph: evt 
	| w |
	w := self world
				ifNil: [^ self].
	w abandonAllHalos; stopStepping: self.
	self submorphs
		do: [:submorph | submorph dismissMorph: evt ].
	self delete! !


!HaloMorph methodsFor: 'stepping' stamp: 'ns 8/16/2002 17:24'!
localHaloBoundsFor: aMorph

	"aMorph may be in the hand and perhaps not in our world"

	| r |

	r _ aMorph topRendererOrSelf worldBoundsForHalo truncated.
	aMorph world = self world ifTrue: [^r].
	^((self transformFromOutermostWorld) globalBoundsToLocal: r) truncated! !


!Morph class methodsFor: 'instance creation' stamp: 'ns 8/19/2002 14:14'!
readFrom: aStream 
	| object |
	aStream reset.
	[[aStream atEnd]
		whileFalse: [aStream skipSeparators.
			[(aStream peekFor: $!!)
				ifTrue: [(Compiler evaluate: aStream nextChunk logged: false)
						scanFrom: aStream]
				ifFalse: [| chunk | 
					chunk _ aStream nextChunk.
					aStream checkForPreamble: chunk.
					Compiler evaluate: chunk logged: false]]
				on: InMidstOfFileinNotification
				do: [:ex | ex resume: true].
			aStream skipStyleChunk]]
		ensure: [aStream close].
	object _ SmartRefStream scannedObject.
	SmartRefStream scannedObject: nil.
	^ object! !


!PolygonMorph methodsFor: 'halo control' stamp: 'ns 8/19/2002 19:34'!
addFlexShellIfNecessary
	^ super addFlexShellIfNecessary! !

!PolygonMorph methodsFor: 'halo control' stamp: 'ns 8/19/2002 19:34'!
heading: newHeading 
	super heading: newHeading! !


!TransformationMorph methodsFor: 'accessing' stamp: 'ns 8/16/2002 15:47'!
scaleToMatch: aPoint
	| scaleFactor tfm originalScale |
	tfm _ transform withScale: 1.0.
	originalScale _ ((tfm localBoundsToGlobal: self renderedMorph fullBounds) corner -
		(tfm localPointToGlobal: self renderedMorph referencePosition)) r.
	"Catch cases where the reference point is on fullBounds corner"
	originalScale < 1.0 ifTrue:[originalScale _ 1.0].
	scaleFactor _ ((self globalPointToLocal: aPoint)
				- self referencePosition) r / originalScale.
	scaleFactor _ scaleFactor < 1.0
		ifTrue: [scaleFactor detentBy: 0.05 atMultiplesOf: 0.25 snap: false]
		ifFalse: [scaleFactor detentBy: 0.1 atMultiplesOf: 0.5 snap: false].
	self adjustAfter:[self scale: ((scaleFactor min: 8.0) max: 0.1)].! !

